{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            Employee:{routeName:'JobRotationEmployeeChange-getjobrotationemployees',table:'job_rotation_employees',modulename:'JobRotationEmployeeChange'}
            //,JobRotation_s:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotation_d:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationTeam_s:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
            //,JobRotationTeam_d:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
        },
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            t.windowButtons.formCancel=false;
            t.checks = {};
            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : "{{ 'JobRotationEmployeeChange.jobrotationsource'|trans }}",
                        labelWidth : '95px',
                        width : 280,
                        height : 310,
                        items : [
                            new mj.form.dateField({
                                title : "{{ 'JobRotationEmployeeChange.date'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'date_s',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.combo({
                                title: "{{ 'JobRotationEmployeeChange.jobrotation'|trans }}",
                                placeHolder: "{{ 'JobRotationEmployeeChange.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation_s',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                store: t.extras.job_rotations
                            }),
                            new mj.form.combo({
                                title: "{{ 'JobRotationEmployeeChange.jobrotationteam'|trans }}",
                                placeHolder: "{{ 'JobRotationEmployeeChange.jobrotationteam_placeholder'|trans }}",
                                dataIndex: 'jobrotationteam_s',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                store: t.extras.job_rotation_teams
                            })
                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f3',
                        title : "{{ 'JobRotationEmployeeChange.jobrotationdest'|trans }}",
                        labelWidth : '95px',
                        width : 280,
                        height : 310,
                        style : 'position:absolute;top:0px;left:655px;',
                        items : [
                            new mj.form.dateField({
                                title : "{{ 'JobRotationEmployeeChange.date'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'date_d',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.combo({
                                title: "{{ 'JobRotationEmployeeChange.jobrotation'|trans }}",
                                placeHolder: "{{ 'JobRotationEmployeeChange.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation_d',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                store: t.extras.job_rotations
                            }),
                            new mj.form.combo({
                                title: "{{ 'JobRotationEmployeeChange.jobrotationteam'|trans }}",
                                placeHolder: "{{ 'JobRotationEmployeeChange.jobrotationteam_placeholder'|trans }}",
                                dataIndex: 'jobrotationteam_d',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                store: t.extras.job_rotation_teams
                            })
                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : "{{ 'JobRotationEmployeeChange.employees'|trans }}",
                        labelWidth : '110px',
                        width : 300,
                        height : 310,
                        style : 'position:absolute;top:0px;left:320px;'
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.buttons.selectNone = t.forms.main.addButton({
                alt: "{{ 'JobRotationEmployeeChange.selectNone'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox',
                scope: t,
                handler: function(){
                    t.checker(0);
                }
            });
            t.buttons.selectAll = t.forms.main.addButton({
                alt: "{{ 'JobRotationEmployeeChange.selectAll'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox-checked',
                scope: t,
                handler: function(){
                    t.checker(1);
                }
            });
            t.day_s=t.forms.main.items[5];
            t.jobrotation_s=t.forms.main.items[6];
            t.jobrotationteam_s=t.forms.main.items[7];

            t.day_d=t.forms.main.items[8];
            t.jobrotation_d=t.forms.main.items[9];
            t.jobrotationteam_d=t.forms.main.items[10];
            t.len=t.forms.main.items.length;
            t.jobrotation_s.on('triggerclick',function(){
                t.clearPersonel();
                t.jobrotationteam_s.clear();
            });

            t.jobrotationteam_s.on('triggerclick',function(){
                t.clearPersonel();
            });

            t.stores.Employee.on('load',function(st){
                t.clearPersonel();
                for(var i = 0,l = st.data.length;i<l;i++){
                    if(t.forms.main.items.getIndex('id','employee_' + st.data[i].code) === -1){
                        t.forms.main.add(
                            new mj.form.checkBox({
                                title : st.data[i].name,
                                id : 'employee_' + st.data[i].code,
                                labelWidth : '260px',
                                labelPos : 'right',
                                dataIndex : 'employee'
                            }),'f2'
                        );
                    }
                }
                t.waitMaskHide();
                t.checks.employee = t.forms.main.items[4].items;
            },t);

            t.jobrotationteam_s.view.on('itemclick',function(){
                var routeName='JobRotationEmployeeChange-getjobrotationemployees';
                var route = Routing.getRoute(routeName);
                var data = {
                    'menuId': t.id,
                    'pg': 1,
                    'lm': 10000,
                    'filters' : [{alias:"jre",fieldname:"day",operator:"=",value:t.day_s.getValue()}
                            ,{alias:"jre",fieldname:"jobrotation",operator:"=",value:t.jobrotation_s.getValue()}
                            ,{alias:"jre",fieldname:"jobrotationteam",operator:"=",value:t.jobrotationteam_s.getValue()}]
                };
                t.waitMaskShow();
                t.stores.Employee.url=Routing.generate(routeName, data);
                t.stores.Employee.load();
            });
            
            t.tabPanels.main.setActive(0);

            //t.forms.main.store.data=t.data[t.modulename].records[0];
            //t.forms.main.store.load();
        },
        checker : function(v){
            var t=this;
            var bi = t.forms.main.items[4].items;
            for(var i=0;i<bi.length;i++){
                bi[i].setValue(v);
            }
        },
        clearPersonel : function(){
            var t=this;
            t.checks = {};
            var _items=t.forms.main.items;
            _items[4].innerEl[0].innerHTML="";
            _items[4].items=[];
            while(_items.length>t.len){
                delete t.forms.main.cachedItems[_items[_items.length-1].id];
                _items[_items.length-1].destroy();
                _items.remove(_items[_items.length-1]);
            }
        },
        editSelectedRecord: function(){
            return;
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            delete f.cachedItems['employee'];
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var employees="";
                    var flag=false;
                    for(var i = 0 , l = t.checks.employee.length;i<l;i++){
                            if(t.checks.employee[i].checked){
                                flag=true;
                                id = t.checks.employee[i].id.replace('employee_','');
                                employees=(employees==""?id:employees+","+id);
                            }
                    }
                    if(flag){
                        t.waitMaskShow();
                        var id = f.getValue('id').id;
                        var versionField = f.getField('version');
                        var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                        var mode = 'update';
                        var routeName = f.modulename + '-' + mode;
                        var route = Routing.getRoute(routeName);
                        var pagerParams = {
                            'id': 0,
                            'v': 1,
                            'pg': 1,
                            'lm': 10
                        };
                        var url = Routing.generate(routeName, pagerParams);
                        var data = f.getValue();
                        data.employees=employees;
                        data.menuId = t.id;
                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                            t.waitMaskShow();
                            t._event='save';
                            $.ajax({
                                url: url,
                                method: "POST",
                                headers: { 
                                    "Content-Type": "application/json",
                                    "X-HTTP-Method-Override": route.methods[0] 
                                },
                                data: JSON.stringify(data),
                                dataType: 'json',
                                success: function(data, textStatus, jqXHR) {
                                    t.clearPersonel();
                                    //t.reset(_f, data);
                                    //t.activateTabGrid();
                                    f.clear();
                                    t.waitMaskHide();
                                },
                                error: function(jqXHR, textStatus, errorThrown) {
                                    t.waitMaskHide();
                                    mj.message({
                                        title: mj.lng.glb.error,
                                        msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                        type: "error",
                                        html: true
                                    });
                                },
                                complete: function(jqXHR, textStatus) {
                                    //t.waitMaskHide();
                                }
                            });
                        }
                    }else{
                        t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
